#include "regs.h"

# let the assembler take care of branch delay slots etc.
.set reorder

.text
.globl SetGSReg


#------------------------------------------------------------------------
# void SetGSReg(u16 reg, u64 data);
# Sets a general GS register
#------------------------------------------------------------------------
.align 7
.ent SetGSReg
SetGSReg:

# wait for empty FIFO
	li	v1, 0x10003020
	li	a3, 0x1f000000
WaitF:	lw	v0, 0x0000(v1)
	and	v0, v0, a3
	nop	# filling with nops to avoid
	nop	#   "Loop length is too short for r5900."
	nop	#   warning
	bne	v0, zero, WaitF
	
# load GIF tag: 0x000000000000000e 1000000000008001: NLOOP=1, EOP=1, NREG=1, REGS0=GIF_AD
	li	v1, 0x000000000000000e
	li	v0, 0x1000000000008001
	pcpyld	v1, v1, v0

# write GIF tag, register and data
	li	v0, 0x10006000  # GIF_FIFO (0x10006000) register
	sq	v1, 0x0000(v0)  # write GIF tag to GIF_FIFO
	pcpyld	v1, a0, a1      # combine register and data in qword
	sq	v1, 0x0000(v0)  # write to GIF_FIFO

# return
	jr	ra
.end SetGSReg
